﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter {
  using System;

  using HeuristicLab.Core;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Configuration;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Data.Pool;
  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;

  public class PooledPushInterpreter : PushInterpreter, IDisposable {

    private readonly PushInterpreterPool pool;

    public PooledPushInterpreter(PushInterpreterPool pool, PushConfiguration config, ManagedPoolProvider<PushProgram> pushProgramPoolProvider, IRandom random = null)
      : base(config, random, pushProgramPoolProvider) {
      this.pool = pool;
    }

    public void Dispose() {
      this.Reset();
      this.Configuration = this.Configuration;
      this.pool.Free(this);
    }
  }
}
